// Copyright (C) Microsoft. All rights reserved.
precision highp float;
uniform lowp sampler2D s_customDistance;
uniform lowp sampler2D s_texture01;
varying vec2 v_texCoord;
varying vec3 vPosCopy;
varying float vDistance;
varying vec4 vPassColor;
varying float vDisableDepthFade;
#define LabelDistanceToZero 1.0
#define PointsAndLabelsDistanceFadeCutoff 0.3
float PositionToDistanceFade(vec3 pos,float localZ,float distanceToZero)
{
vec2 pc=pos.xy/pos.z;
vec2 texcoords=vec2((pc.x+1.0)*0.5,
(pc.y+1.0)*0.5);
vec4 reconstruct=vec4(
65536.0*255.0/16777216.0,
256.0*255.0/16777216.0,
1.0*255.0/16777216.0,
0.0*255.0/16777216.0);
lowp vec4 value=texture2D(s_customDistance,texcoords);
float val=dot(value,reconstruct);
return clamp(1.0-((localZ-val)/(val*distanceToZero)),0.0,1.0);
}
float PointsAndLabelsDistanceFade(vec3 pos,float localZ,float distanceToZero,float disableDepthFade)
{
float depthFadeResult=PositionToDistanceFade(pos,localZ,distanceToZero);
return max(disableDepthFade,
depthFadeResult<PointsAndLabelsDistanceFadeCutoff?0.0:depthFadeResult);
}
void main()
{
vec4 color=vPassColor;
vec4 alphaColor=texture2D(s_texture01,v_texCoord);
color.a*=(alphaColor.a*15.0+(alphaColor.b*15.0)*16.0)/255.0;
float depthFade=PointsAndLabelsDistanceFade(vPosCopy,vDistance,LabelDistanceToZero,vDisableDepthFade);
color.a*=depthFade;
gl_FragColor=color;
}
