// Copyright (C) Microsoft. All rights reserved.
attribute vec3 vPosition0;
attribute vec2 AlphaParameters;
attribute vec4 vColor;
attribute vec2 vTexCoord0;
uniform mat4 View;
uniform mat4 Proj;
uniform vec3 Camera;
uniform float Near;
uniform float Far;
uniform vec2 ViewSize;
uniform mat4 World;
uniform vec2 TextureAtlasPixelSize;
varying vec2 v_texCoord;
varying vec3 vPosCopy;
varying float vDistance;
varying vec4 vPassColor;
varying float vDisableDepthFade;
vec2 PixelCoordinateToUV(vec2 coordInPixel,vec2 textureSize)
{
return coordInPixel/textureSize;
}
void main()
{
vPassColor=vColor;
vPassColor.a*=AlphaParameters.x;
vec4 position=World*vec4(vPosition0,1.0);
vDistance=length(Camera-position.xyz)/Far;
position=(Proj*View)*position;
gl_Position=position;
position/=position.w;
vPosCopy=position.xyw;
vDisableDepthFade=AlphaParameters.y;
v_texCoord=PixelCoordinateToUV(vTexCoord0,TextureAtlasPixelSize);
}
