// Copyright (C) Microsoft. All rights reserved.
attribute vec3 vPosition0;
attribute vec4 vNormal;
attribute vec4 vTexCoord0;
attribute float Alpha;
attribute float IsLyingFlat;
attribute float DisableDepthFade;
uniform mat4 View;
uniform mat4 Proj;
uniform vec3 Camera;
uniform float Near;
uniform float Far;
uniform vec2 ViewSize;
uniform mat4 World;
uniform vec2 TextureAtlasPixelSize;
varying vec2 v_texCoord;
varying vec3 vPosCopy;
varying float vAlpha;
varying float vDistance;
varying float vDisableDepthFade;
vec2 Decode2DNormal(vec2 normal,vec2 viewSize)
{
return normal/viewSize;
}
vec2 EncodedPixelCoordinateToUV(vec4 coordInPixel,vec2 textureSize)
{
vec2 decoded=coordInPixel.rb*256.0+coordInPixel.ga;
return decoded/textureSize;
}
void main()
{
vAlpha=Alpha;
vDisableDepthFade=DisableDepthFade;
vec4 position=World*vec4(vPosition0,1.0);
vDistance=length(Camera-position.xyz)/Far;
position=(Proj*View)*position;
if(IsLyingFlat<0.5)
{
vec2 clipSpaceExpansion=Decode2DNormal(vNormal.xy,ViewSize)*position.w;
position.xy+=clipSpaceExpansion;
}
vPosCopy=position.xyw;
position.z=(2.0*log(position.w+1.0)/log(Far+1.0))-1.0;
position.z*=position.w;
gl_Position=position;
v_texCoord=EncodedPixelCoordinateToUV(vTexCoord0,TextureAtlasPixelSize);
}
